#ifdef BEO
C**********************************************************************C
C***  Slave version just runs those parameters requested by master  ***C
C**********************************************************************C
      SUBROUTINE RUNSLAVE(IFAIL)
      USE PESTDATA
      USE BEOPEST, ONLY:BEOCOMMAND
      IMPLICIT NONE
      ALLOCATABLE      PAR,OBS,NW,LL,LCINS,IIOBS,OBSN1,OBSN2,
     |                 PWORD,PARDEL,MRKDEL,A
      LOGICAL          BEOGET
      INTEGER          IFAIL
      INTEGER          IERR
      INTEGER          SVDA_PARSET
      INTEGER          SV
      INTEGER          BEOSLAVEFLAG,NPP,ONE,TWO,I
      INTEGER          JFAIL,NP,NT,NS,ASIZE,NUML,NINSTR,IOS,ILINE,
     |                 INCPAR,NBLBMX,NCALL,MCALL,
     |                 NW(:),LL(:),LCINS(:),IIOBS(:),OBSN1(:),OBSN2(:)
      DOUBLE PRECISION PAR(:),OBS(:)
      CHARACTER        PARDEL(:),MRKDEL(:),A(:)
      CHARACTER*23     PWORD(:)
      CHARACTER*2000   BUF
      COMMON /MODCAL/  NCALL,MCALL


      IFAIL=0
      ONE=1
      TWO=2
      SVDA_PARSET=0
      BEOSLAVEFLAG=0
      if (SVDA.eq.1) THEN
        BEOSLAVEFLAG=1
        call INITIALISE_BASE(IFAIL,SVDA_SCALADJ,BEOSLAVEFLAG)
C        if (IFAIL.ne.0) call BEOFATAL('INITIALISE BASE failed')
        if(ifail.ne.0)go to 9900
      END IF

C  Allocate memory for files, parameters and observations
      allocate(PARDEL(NTPLFLE),MRKDEL(NINSFLE),STAT=IOS)
      if (IOS.ne.0) call BEOFATAL('ALLOCATE del failed')
      allocate(PAR(NPAR),NW(NPAR),PWORD(NPAR),STAT=IOS)
      if (IOS.ne.0) call BEOFATAL('ALLOCATE par failed')
      allocate(OBS(NOBS),IIOBS(NOBS),OBSN1(NOBS),OBSN2(NOBS),STAT=IOS)
      if (IOS.ne.0) call BEOFATAL('ALLOCATE obs failed')

C  Read instruction files
      call IOCTL(JFAIL,NPAR,NTPLFLE,NINSFLE,NUML,ASIZE,NINSTR,NBLBMX,
     |NW,TEMPFLE,INFLE,INSFLE,OUTFLE,PARDEL,MRKDEL,APAR,CLINE,ILINE,
     +ONE)
      if(jfail.ne.0)then
        call BEOFATAL_RET()
        ifail=1
        go to 9900
      end if
C  Allocate memory for templates
      if (NUML.eq.0) NUML = 1
      allocate(A(ASIZE),LL(NUML),LCINS(NINSTR),STAT=IOS)
      if (IOS.ne.0) call BEOFATAL('ALLOCATE tpl/ins failed')
C  Read instruction file
      call READINS(LCINS,NINSTR,A,ASIZE,MRKDEL,JFAIL)
      if (JFAIL.ne.0) call BEOFATAL('READINS failed')

C     npp=8192                                 ! I don't like this. But its only the slave.
C     call BEOINIT(TRIM(BEOCOMMAND),NPP)

C  Get parameter count NP and target count NT from master
C  Use this as a sanity check
      call BEOCAST(NP,NT,NS,SV)
      if (NP.ne.NPAR .or. NT.ne.NOBS) then
        print *,'NPAR Slave=',NPAR,' Master=',NP
        print *,'NOBS Slave=',NOBS,' Master=',NT
        call BEOFATAL('Par/Obs count mismatch between master and slave')
      endif
      if(SV.ne.SVDA)then
        print *,'SVDA Slave=',SVDA,' Master=',SV
        call BEOFATAL('SVDA mismatch between master and slave.')
      end if

C  Wait for set of parameters
      MCALL = 0
      do while (BEOGET(PAR,IFAIL))
        IF(IFAIL.NE.0) GO TO 9900
        MCALL = MCALL+1
        IF(MCALL.EQ.1)THEN
        CALL IOCTL(JFAIL,NPAR,NTPLFLE,NINSFLE,NUML,ASIZE,NINSTR,NBLBMX,
     |  NW,TEMPFLE,INFLE,INSFLE,OUTFLE,PARDEL,MRKDEL,APAR,CLINE,ILINE,
     +  TWO)
        if(jfail.ne.0)then
          call BEOFATAL_RET()
          ifail=1
          go to 9900
        end if
        END IF
C  Write model input files
        INCPAR = 0
        call INWRIT(JFAIL,NPAR,PRECIS,NOPNT,NTPLFLE,NW,PAR,SCALE,
     |    OFFSET,PARDEL,PWORD,INFLE,TEMPFLE,APAR,CLINE,MESSFILE,INCPAR,
     |    ITRANS,NOBS)
        if (JFAIL.ne.0) call BEOFATAL('INWRIT failed')

C -- Delete model output files.

        do i=1,ninsfle
          call delfile1(jfail,outfle(i),cline)
          if(jfail.ne.0) then
            ifail=1
            go to 9900
          end if
        end do

C  Run model
        write(6,10)
10      format(/,' Running model ....')
        call SYSTEM(TRIM(COMLIN(1)))
C  Read model output files
        call OUTRD(JFAIL,NINSTR,NINSFLE,ASIZE,NUML,NOBS,NBLBMX,LCINS,
     |             LL,OBSN1,OBSN2,IIOBS,OBS,AOBS,A,MRKDEL,CLINE,BUF)
c        if (JFAIL.ne.0) print *,'OUTRD failed - continuing'
        if(jfail.ne.0)then
          write(6,21)
21        format(/,' Problem encountered:-')
          call write_pest_message(2)
        else
          write(6,20)
20        format(' Model run complete.')
        end if

C  Send results back
        IF(JFAIL.EQ.0)THEN
          call BEOPUT(PAR,OBS)
        ELSE
          OBS=-1.01D300                 !an array
          call BEOPUT(PAR,OBS)
          IFAIL=1
        END IF
      enddo
C     print '(A,I6)','Total model calls:',MCALL

9900  continue

      call svda_deallocate()

      if(allocated(nw)) deallocate(nw,stat=ierr)
      if(allocated(ll)) deallocate(ll,stat=ierr)
      if(allocated(lcins)) deallocate(lcins,stat=ierr)
      if(allocated(iiobs)) deallocate(iiobs,stat=ierr)
      if(allocated(obsn1)) deallocate(obsn1,stat=ierr)
      if(allocated(obsn2)) deallocate(obsn2,stat=ierr)
      if(allocated(par)) deallocate(par,stat=ierr)
      if(allocated(obs)) deallocate(obs,stat=ierr)
      if(allocated(pardel)) deallocate(pardel,stat=ierr)
      if(allocated(mrkdel)) deallocate(mrkdel,stat=ierr)
      if(allocated(a)) deallocate(a,stat=ierr)
      if(allocated(pword)) deallocate(pword,stat=ierr)

      if(ifail.ne.0) ifail=1

      RETURN

      END
C**********************************************************************C
C******  Routine to schedule manage slaves to do series of jobs  ******C
C**********************************************************************C
C  STAT is node status
C   -1 = offline
C    0 = idle
C  k>0 = running job k
C
C  MODE is the job status
C   -1 = not run
C    0 = run
C  k>0 = running on node k
      SUBROUTINE RUNMASTER(PARREG,OBSREG,NJOB,JFAIL,
     +irestart,ptunit,pitn,ptfile,workvecdim,workvec,
     +action_lamforgive)
      USE PESTDATA
      USE BEOPEST
      USE BEORUN_DATA
      use beopriv, only : strt,suspect,av_operating,text,oldtext,
     +                    node0_keep,node1_keep
      IMPLICIT NONE
      integer          irestart,ptunit,pitn,workvecdim
      integer          action_lamforgive
      integer          ierr,ptcount,titn,itemps,jj,icflag
      integer          i,istopcount,jjfail,istop,waitflag
      integer          dd,mm,yy,hh,min
      integer          bsn
      integer          newnode
      real             ss
C      ALLOCATABLE      MODE,STAT,PAR
      INTEGER          PARREG,OBSREG,NJOB,JFAIL,BEOSTAT,NCALL,MCALL,
C     |                 MODE(:),STAT(:),node,kjob,node0,node1,
     |                 node,kjob,node0,node1,
     |                 idle,next,done,IOS
      double precision workvec(workvecdim)
C      DOUBLE PRECISION PAR(:),fast,BEOWALL
      DOUBLE PRECISION fast,BEOWALL
      double precision current_walltime,walltime,dtemp
      double precision  average_time
      CHARACTER*256    BEOTEXT
      character*10     atemp,anode,ajob
      character*11     bresult1,bresult2,bresult
      character*(*)    ptfile
      COMMON /MODCAL/  NCALL,MCALL
      COMMON /SSTOP/ISTOP

      icflag=0
      istopcount=0
      waitflag=0


C  Allocate memory for parameter and slave arrays
      if(ialloc_beorun_data.eq.0)then
        allocate(PAR(NPAR),MODE(NJOB),STAT(MAXNODE),STAT=IOS)
        if (IOS.ne.0)
     +  call BEOFATAL('Cannot allocate memory in RUNMASTER')
        ialloc_beorun_data=1
        pardim=npar
        modedim=njob
        statdim=maxnode
C  Mark all slaves as dead
        stat = -1
C  Mark all jobs as not run
	mode = -1
	node0_keep=0
	node1_keep=1
      else
        if(npar.gt.pardim)then
          deallocate(par,stat=ios)
          if(ios.ne.0) go to 5
          allocate(par(npar),stat=ios)
          if(ios.ne.0) go to 5
          pardim=npar
        end if
        if(njob.gt.modedim)then
          deallocate(mode,stat=ios)
          if(ios.ne.0) go to 5
          allocate(mode(njob),stat=ios)
          if(ios.ne.0) go to 5
          modedim=njob
        end if
        if(maxnode.gt.statdim)then
          deallocate(stat,stat=ios)
          if(ios.ne.0) go to 5
          allocate(stat(maxnode),stat=ios)
          if(ios.ne.0) go to 5
          statdim=maxnode
        end if
        go to 10
5       call beofatal('Memory allocation error in RUNMASTER')
10      continue
      end if

C  Mark all slaves as dead
      if(node0_keep.ne.0)then
        do node=node0_keep,node1_keep
          if(stat(node).ne.-999)then
            STAT(node) = -1
          end if
        end do
      end if
C  Mark all jobs as not run
      MODE = -1
C  kjob is the number of jobs completed
      kjob = 0

      node_new=-1

C -- The restart file situation is handled.

        if(irestart.eq.1)then
          call ffopen(jfail,-ptunit,'w',ptfile,25,cline)
          if(jfail.ne.0)then
            jfail=0
            irestart=0
            go to 1050
          end if
          write(ptunit,iostat=ierr)pitn
#ifdef FLUSHFILE
          call flush(ptunit)
#endif
        else if(irestart.eq.2)then
          ptcount=0
          call ffopen(jfail,-ptunit,'r',ptfile,22,cline)
          if(jfail.ne.0) then
            jfail=0
            go to 2000
          end if
          titn=0
          read(ptunit,iostat=ierr)titn
          if(pitn.ne.titn)then
            close(unit=ptunit,iostat=ierr,status='delete')
            go to 2000
          end if
          do
            read(ptunit,err=1900,end=1900) itemps
            do jj=1,nobs
              workvec(jj)=-1.1d300
            end do
            mode(itemps)=0
            ptcount=ptcount+1
            read(ptunit,err=1900,end=1900)
     +      (workvec(jj),jj=1,nobs)
            call store_parallel_register
     +      (jjfail,nobs,ippo,itemps,workvec,obsregfile)
            if(jjfail.ne.0) go to 9891
          end do
1900      close(unit=ptunit,status='delete',iostat=ierr)
          if(itemps.ne.0)then
            do jj=1,nobs
              if(workvec(jj).lt.-1.0d300)then
                ptcount=ptcount-1
                mode(itemps)=-1
                go to 1901
              end if
            end do
          end if
1901      continue
2000      continue
#ifdef INTEL
          call writint(atemp,ptcount)
          write(6,1049) trim(atemp)
1049      format('    Results from ',a,
     +    ' model runs read from restart file.')
          icflag=1
#endif
          kjob=ptcount
C          ncall=ncall+ptcount
          call ffopen(jfail,-ptunit,'w',ptfile,25,cline)
          if(jfail.ne.0)then
            jfail=0
            irestart=0
            go to 1050
          end if
          write(ptunit,iostat=ierr)pitn
          if(ptcount.ne.0)then
            do i=1,njob
              if(mode(i).eq.0)then
                call retrieve_parallel_register
     +          (jjfail,nobs,ippo,i,workvec,obsregfile)
                if(jjfail.ne.0) go to 9891
                write(ptunit,iostat=ierr)i
                write(ptunit,iostat=ierr)(workvec(jj),jj=1,nobs)
              end if
            end do
          end if
#ifdef FLUSHFILE
          call flush(ptunit)
#endif
          if(ptcount.eq.njob) go to 9999
        end if

1050    continue

        call BEONODE(node0,node1,newnode)
        node_new=newnode
        if(node1.lt.node0)then
          write(6,*)
          write(6,1051)
1051      format('    Waiting for at least one slave to appear....')
          waitflag=1
        end if

C  Launch jobs until all jobs are completed
      do while (kjob.lt.NJOB)

C -- See whether the escape key has been pressed.

        if(istopcount.eq.100)then
          istopcount=0
          call stopress(0)
          if((istop.eq.2).or.(istop.eq.1)) then
            if(irestart.ne.0) close(unit=ptunit,iostat=ierr)
            go to 9999
          end if
        else
          istopcount=istopcount+1
        end if

C       Poll all slaves to check for a change in status
        call BEONODE(node0,node1,newnode)
        node_new=newnode

C -- If the new node is actually an old node with a job running the situation
C    is now rectified.

        if(node_new.gt.0)then
          if(stat(node_new).gt.0)then
            call date_and_time(date=bresult1,time=bresult2)
C           read(bresult1,'(i4,i2,i2)') yy,mm,dd
            read(bresult2,'(i2,i2,f6.0)') hh,min,ss
            write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss
            if(bresult(7:7).eq.' ')bresult(7:7)='0'
            call writint(anode,node_new)
            call writint(ajob,stat(node_new))
            write(irmr,10131) bresult,trim(ajob),trim(anode)
10131       format(3x,a,':- model run ',a,
     +      ' previously running on reappeared node ',a,
     +      ' assigned unstarted status.')
#ifdef FLUSHFILE
            call flush(irmr)
#endif
            mode(stat(node_new))=-1
            stat(node_new)=-1
          end if
          node_new=-1
        end if

        do node=node0,node1
C         Slave is idle
          bsn=BEOSTAT(NODE)
          if (BSN.gt.0) then
C           Mark job as completed
            if(STAT(node).eq.-999)then
              call date_and_time(date=bresult1,time=bresult2)
              read(bresult2,'(i2,i2,f6.0)') hh,min,ss
              write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss
              if(bresult(7:7).eq.' ')bresult(7:7)='0'
              call writint(anode,node)
              write(irmr,1018) bresult,trim(anode)
1018          format(3x,a,':- model run completed on node ',a,
     +        '; old run so results not needed.')
#ifdef FLUSHFILE
              call flush(irmr)
#endif
              dtemp=beowall(node)
              average_walltime=average_time(dtemp)
              stat(node)=-1
            else if(STAT(node).gt.0)then
              if(mode(stat(node)).gt.0)then
                kjob = kjob+1
#ifdef INTEL
                if((kjob.eq.1).or.(icflag.eq.1))then
                  write(6,1010)
1010              format('    - number of runs completed...')
                  write(6,'(a)',advance='no') '     '
                  icflag=0
                end if
                write(6,1020) kjob
1020            format(i6,$)
                if(kjob.eq.NJOB)then
                  write(6,*)
                else if(mod(kjob,12).eq.0)then
                  write(6,*)
                  write(6,'(a)',advance='no') '     '
                end if
#endif
                MODE(STAT(node)) = 0
C  Store  parameters and observations
                call BEOSTORE(node,STAT(node),PARREG,OBSREG,
     +          irestart,ptunit)
C  Write to the run management file.
                call date_and_time(date=bresult1,time=bresult2)
C               read(bresult1,'(i4,i2,i2)') yy,mm,dd
                read(bresult2,'(i2,i2,f6.0)') hh,min,ss
                write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss
                if(bresult(7:7).eq.' ')bresult(7:7)='0'
                call writint(anode,node)
                call writint(ajob,stat(node))
                write(irmr,1012) bresult,trim(ajob),trim(anode)
1012            format(3x,a,':- model run ',a,
     +          ' completed on node ',a,'.')
#ifdef FLUSHFILE
                call flush(irmr)
#endif
                if(last_first_obs.lt.-1.0d300)then
                  if(action_lamforgive.eq.0)then
                    call writint(anode,node)
                    write(errmsg,1015) trim(anode),trim(beotext(node))
1015                format('Model run failure has occurred on node ',a,
     +              ' identified as "',a,'". See screen printout of ',
     +              'pertinent slave for error message details.')
                    go to 9891
                  end if
                else
C -- Update average walltime.
                  dtemp=beowall(node)
                  average_walltime=average_time(dtemp)
                end if
              else
                call date_and_time(date=bresult1,time=bresult2)
                read(bresult2,'(i2,i2,f6.0)') hh,min,ss
                write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss
                if(bresult(7:7).eq.' ')bresult(7:7)='0'
                call writint(anode,node)
                write(irmr,1018) bresult,trim(anode)
#ifdef FLUSHFILE
                call flush(irmr)
#endif
                dtemp=beowall(node)
                average_walltime=average_time(dtemp)
              endif
            end if
C           Mark slave as idle
            STAT(node) = 0
            suspect(node)=0
C  Slave has died
          else if (bsn.lt.0) then
C  Reschedule job
            if (STAT(node).gt.0) then

              call date_and_time(date=bresult1,time=bresult2)
C             read(bresult1,'(i4,i2,i2)') yy,mm,dd
              read(bresult2,'(i2,i2,f6.0)') hh,min,ss
              write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss
              if(bresult(7:7).eq.' ')bresult(7:7)='0'
              call writint(anode,node)
              call writint(ajob,stat(node))
              write(irmr,1013) bresult,trim(anode),trim(ajob)
1013          format(3x,a,':- communications failure on node ',a,'; ',
     +        'model run ',a,' will be re-assigned to another node.')
C              print '(A,I4,2A)','FAILED job',STAT(node),
C     |          ' on node ',TRIM(BEOTEXT(node))
#ifdef FLUSHFILE
              call flush(irmr)
#endif
              MODE(STAT(node)) = -1
            endif
C   Mark slave as offline
            STAT(node) = -1
            text(node)=' '
            oldtext(node)=' '
          else if(bsn.eq.0)then

C   Check that no runs are overdue.

            if(stat(node).gt.0)then
              if(mode(stat(node)).gt.0)then
                if(suspect(node).eq.0)then
                  if(av_operating.ne.0)then
                    current_walltime= walltime()-strt(node)
                    if(current_walltime.gt.3.0*average_walltime)then              !abitrary
                      suspect(node)=1
                      mode(stat(node))=-1
                      call date_and_time(date=bresult1,time=bresult2)
                      read(bresult2,'(i2,i2,f6.0)') hh,min,ss
                      write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)')
     +                hh,min,ss
                      if(bresult(7:7).eq.' ')bresult(7:7)='0'
                      call writint(anode,node)
                      call writint(ajob,stat(node))
                      write(irmr,1014) bresult,trim(anode),trim(ajob)
1014                  format(3x,a,':- overdue run on node ',a,'; ',
     +                'model run ',a,' may be re-assigned to ',
     +                'another node.')
#ifdef FLUSHFILE
                      call flush(irmr)
#endif
                    end if
                  end if
                end if
              end if
            end if
          endif
        enddo

C  Scan slaves to find the fastest idle node
        idle = 0
        fast = 1d300
        do node=node0,node1
          if(suspect(node).eq.0)then
          if (STAT(node).eq.0 .and. BEOWALL(node).le.fast) then
            fast = BEOWALL(node)
            idle = node
          end if
          endif
        enddo
C  Find next unscheduled job
        do next=1,NJOB
          if (MODE(next).lt.0) goto 100
        enddo
        next = 0

C  Push next job to idle slave
100     continue
        if (idle.gt.0 .and. next.gt.0) then
          if(waitflag.eq.1)then
C            write(6,101)
C101         format('    Node has appeared; commencing a model run.',/)
            waitflag=0
          end if
          STAT(idle) = next
          MODE(next) = idle
C  Retrieve parameters
          call RETRIEVE_PARALLEL_REGISTER(IOS,
     |      NPAR,PARREG,next,PAR,PARREGFILE)
          if (IOS.ne.0) call BEOFATAL('Cannot retrieve PAR ')
C  Push to slave
          call BEOPUSH(idle,PAR)
C  Write to the run management file.
          call date_and_time(date=bresult1,time=bresult2)
C         read(bresult1,'(i4,i2,i2)') yy,mm,dd
          read(bresult2,'(i2,i2,f6.0)') hh,min,ss
          write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss
          if(bresult(7:7).eq.' ')bresult(7:7)='0'
          call writint(anode,idle)
          call writint(ajob,next)
          write(irmr,1011) bresult,trim(ajob),trim(anode)
1011      format(3x,a,':- model run ',a,' commencing on node ',a,'.')
C  Nothing to do right now so sleep a spell before trying again
        else
          call MSLEEP(5)
        endif
      enddo

C  Identify any nodes with unfinished runs.

      node0_keep=node0
      node1_keep=node1
      if(node0.gt.0)then
        do node=node0,node1
          if(stat(node).gt.0)then
            if(mode(stat(node)).gt.0)then
              stat(node)=-999
            end if
          end if
        end do
      end if

      go to 9999

9891  jfail=1


9999  continue
      NCALL = NCALL+NJOB

C  Done - free MODE and STAT arrays
C      deallocate(MODE,STAT,stat=ierr)
C      deallocate(PAR,stat=ierr)
      if(irestart.ne.0) close(unit=ptunit,iostat=ierr)
      return

      END
C**********************************************************************C
C**************  Get number of 'fast' slaves available  ***************C
C**********************************************************************C
      SUBROUTINE FASTSLAVES(NUMSLAVE)
      USE BEOPEST
      IMPLICIT NONE
      INTEGER          NUMSLAVE,node,node0,node1
      INTEGER          newnode
      DOUBLE PRECISION fast,BEOWALL

C  Check for new nodes and get range of nodes
      call BEONODE(node0,node1,newnode)
      node_new=newnode

C  Find fastest node (0 means new)
      fast = 1d300
      do node=node0,node1
        fast = MIN(BEOWALL(node),fast)
      enddo
      fast = max(fast,1D0)

C  Count nodes faster than 2*fast
      NUMSLAVE = 0
      do node=node0,node1
        if (BEOWALL(node).le.2*fast) NUMSLAVE = NUMSLAVE+1
      enddo
      END
C**********************************************************************C
C***********************  Read instruction file  **********************C
C**********************************************************************C
      SUBROUTINE READINS(LCINS,NINSTR,A,ASIZE,MRKDEL,JFAIL)
      USE PESTDATA
      IMPLICIT NONE
      INTEGER NINSTR
      INTEGER I,J,INS,ISUM,LCINS(NINSTR),ASIZE,NBLC,JFAIL
      CHARACTER MRKDEL(NINSFLE),A(ASIZE)

      INS  = 0
      ISUM = 0
      do I=1,NINSFLE
        call FFOPEN(JFAIL,INST,'r',INSFLE(I),78,CLINE)
        if (JFAIL.ne.0) RETURN
        read(INST,*)
        INS = INS+1
        CLINE(1:1) = CHAR(2)
        CLINE(2:2) = ' '
        CLINE(3:LEN(CLINE)) = OUTFLE(I)
        LCINS(INS) = ISUM+1
        do J=1,LEN_TRIM(CLINE)
          ISUM = ISUM+1
          A(ISUM) = CLINE(J:J)
        enddo
50      READ(INST,'(A)',END=180) CLINE
        call TABREM(CLINE)
        if (INDEX(CLINE,MRKDEL(I)).eq.0) call CMPRSS(CLINE)
        NBLC = LEN_TRIM(CLINE)
        if (NBLC.eq.0) goto 50
        INS = INS+1
        LCINS(INS) = ISUM+1
        do J=1,NBLC
          ISUM = ISUM+1
          A(ISUM) = CLINE(J:J)
        enddo
        goto 50
180     CLOSE(UNIT=INST)
      enddo
      END
#endif



! -- Other matters.
!    Send security code with each job.
